-- Tone Control Unit: Hierarchical

library ieee;
use ieee.std_logic_1164.all;
use IEEE.STD_LOGIC_ARITH.ALL;
entity audio_effects is
  port ( AO : out std_logic_vector(2 downto 0);
    TONE, CLK : in std_logic);
end audio_effects;

architecture behavioral of audio_effects is
  oldMid <= 0;
  oldLow <= 0;
begin
process (CLK)
begin
  -- provides 3 audio channels, with fc ~ 238 Hz for mid/low
  if (CLK'event and (CLK = '1')) then
    A(2) <= AI - oldLow - oldMid;
    A(1) <= (A(2)/32) + oldMid;
    A(0) <= (A(1)/32) + oldLow;
  endif;
end process;
  oldMid <= A(1);
  oldLow <= A(0);
  A2 <= A(2);
  A1 <= A(1);
  A0 <= A(0);
end behavioral;

-------------------------------------------------------------------------------
-- NEED TO WRITE THESE VALUES TO A REGISTER or RAM !!! --
-------------------------------------------------------------------------------

--- IMPLEMENT REAL TIME GAIN CONTROL VIA C INTERFACE --
--  NEED OPB, READ IN VALUES, MULTIPLY by volume in C
--  then output back to different location on the register

-------------------------------------------------------------------------------
-- READ 3 INPUTS BACK FROM REGISTER/RAM
-------------------------------------------------------------------------------

-- Sums 3 inputs
library ieee;
use ieee.std_logic_1164.all;
use IEEE.STD_LOGIC_ARITH.ALL;
entity summation_3_inputs is
  port (Y : in std_logic_vector(2 downto 0); -- takes 3 input channels
        POUT : out std_logic); -- 1 output channel
end summation_3_inputs;

architecture function_table of summation_10_inputs is
begin
  POUT <= Y(1) + Y(2) + Y(0);
end function_table;
